Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Proactor_Impl Class Reference

A manager for asynchronous event demultiplexing. This class is the base class for all the concrete implementation classes. More...

`#include <Proactor_Impl.h>`

Inheritance diagram for ACE_Proactor_Impl

[legend]
Collaboration diagram for ACE_Proactor_Impl:

[legend]
List of all members.

## Public Methods
virtual | ~ACE_Proactor_Impl (void)
| Virtual destruction.
virtual int | close (void) = 0
| Close the IO completion port.
virtual int | register_handle (ACE_HANDLE handle, const void *completion_key) = 0
| This method adds the <handle> to the I/O completion port. This function is a no-op function for Unix systems.
virtual int | handle_events (ACE_Time_Value &wait_time) = 0
virtual int | handle_events (void) = 0
virtual int | wake_up_dispatch_threads (void) = 0
| Add wakeup dispatch threads (reinit).
virtual int | close_dispatch_threads (int wait) = 0
| Close all dispatch threads.
virtual size_t | number_of_threads (void) const = 0
| Number of thread used as a parameter to CreatIoCompletionPort.
virtual void | number_of_threads (size_t threads) = 0
virtual ACE_HANDLE | get_handle (void) const = 0
| Get the event handle.
virtual ACE_Asynch_Read_Stream_Impl* | create_asynch_read_stream (void) = 0
| Create the correct implementation class for doing Asynch_Read_Stream.
virtual ACE_Asynch_Write_Stream_Impl* | create_asynch_write_stream (void) = 0
| Create the correct implementation class for doing Asynch_Write_Stream.
virtual ACE_Asynch_Read_File_Impl* | create_asynch_read_file (void) = 0
| Create the correct implementation class for doing Asynch_Read_File.
virtual ACE_Asynch_Write_File_Impl* | create_asynch_write_file (void) = 0
| Create the correct implementation class for doing Asynch_Write_File.
virtual ACE_Asynch_Accept_Impl* | create_asynch_accept (void) = 0
| Create the correct implementation class for doing Asynch_Accept.
virtual ACE_Asynch_Transmit_File_Impl* | create_asynch_transmit_file (void) = 0
| Create the correct implementation class for doing Asynch_Transmit_File.
virtual ACE_Asynch_Read_Dgram_Impl* | create_asynch_read_dgram (void) = 0
| Create the correct implementation class for doing Asynch_Read_Dgram.
virtual ACE_Asynch_Write_Dgram_Impl* | create_asynch_write_dgram (void) = 0
| Create the correct implementation class for doing Asynch_Write_Dgram.
virtual ACE_Asynch_Read_Stream_Result_Impl* | create_asynch_read_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class.
virtual ACE_Asynch_Write_Stream_Result_Impl* | create_asynch_write_stream_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Write_Stream::Result.
virtual ACE_Asynch_Read_File_Result_Impl* | create_asynch_read_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, u_long offset, u_long offset_high, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Read_File::Result.
virtual ACE_Asynch_Write_File_Result_Impl* | create_asynch_write_file_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block &message_block, u_long bytes_to_write, const void* act, u_long offset, u_long offset_high, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Write_File::Result.
virtual ACE_Asynch_Read_Dgram_Result_Impl* | create_asynch_read_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_read, int flags, int protocol_family, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result.
virtual ACE_Asynch_Write_Dgram_Result_Impl* | create_asynch_write_dgram_result (ACE_Handler &handler, ACE_HANDLE handle, ACE_Message_Block *message_block, size_t bytes_to_write, int flags, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result.
virtual ACE_Asynch_Accept_Result_Impl* | create_asynch_accept_result (ACE_Handler &handler, ACE_HANDLE listen_handle, ACE_HANDLE accept_handle, ACE_Message_Block &message_block, u_long bytes_to_read, const void* act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Accept::Result.
virtual ACE_Asynch_Transmit_File_Result_Impl* | create_asynch_transmit_file_result (ACE_Handler &handler, ACE_HANDLE socket, ACE_HANDLE file, ACE_Asynch_Transmit_File::Header_And_Trailer *header_and_trailer, u_long bytes_to_write, u_long offset, u_long offset_high, u_long bytes_per_send, u_long flags, const void *act, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = ACE_SIGRTMIN) = 0
| Create the correct implementation class for ACE_Asynch_Transmit_File::Result.
virtual ACE_Asynch_Result_Impl* | create_asynch_timer (ACE_Handler &handler, const void *act, const ACE_Time_Value &tv, ACE_HANDLE event = ACE_INVALID_HANDLE, int priority = 0, int signal_number = 0) = 0
virtual int | post_wakeup_completions (int how_many) = 0

## Detailed Description

A manager for asynchronous event demultiplexing. This class is the base class for all the concrete implementation classes.

See the Proactor pattern description at http://www.cs.wustl.edu/~schmidt/proactor.ps.gz for more details.

## Constructor & Destructor Documentation

ACE_Proactor_Impl::~ACE_Proactor_Impl ( | void )`[inline, virtual]`

| Virtual destruction.

## Member Function Documentation

int ACE_Proactor_Impl::close ( | void )`[pure virtual]`

| Close the IO completion port. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::close_dispatch_threads ( | int wait )`[pure virtual]`

| Close all dispatch threads. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Accept_Impl * ACE_Proactor_Impl::create_asynch_accept ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Accept. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Accept_Result_Impl * ACE_Proactor_Impl::create_asynch_accept_result ( | ACE_Handler & handler,
| ACE_HANDLE listen_handle,
| ACE_HANDLE accept_handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Accept::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_Dgram_Impl * ACE_Proactor_Impl::create_asynch_read_dgram ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Read_Dgram. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_Dgram_Result_Impl * ACE_Proactor_Impl::create_asynch_read_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_read,
| int flags,
| int protocol_family,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Dgram::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_File_Impl * ACE_Proactor_Impl::create_asynch_read_file ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Read_File. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_File_Result_Impl * ACE_Proactor_Impl::create_asynch_read_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Read_File::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_Stream_Impl * ACE_Proactor_Impl::create_asynch_read_stream ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Read_Stream. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Read_Stream_Result_Impl * ACE_Proactor_Impl::create_asynch_read_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_read,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Read_Stream::Result class. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Result_Impl * ACE_Proactor_Impl::create_asynch_timer ( | ACE_Handler & handler,
| const void * act,
| const ACE_Time_Value & tv,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = 0 )`[pure virtual]`

| Create the correct implementation object for the Timer result. POSIX_SIG_Proactor will create a Timer object with a meaningful signal number, if you leave the signal number as 0. Reimplemented in ACE_POSIX_Proactor, ACE_POSIX_SIG_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Transmit_File_Impl * ACE_Proactor_Impl::create_asynch_transmit_file ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Transmit_File. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Transmit_File_Result_Impl * ACE_Proactor_Impl::create_asynch_transmit_file_result ( | ACE_Handler & handler,
| ACE_HANDLE socket,
| ACE_HANDLE file,
| ACE_Asynch_Transmit_File::Header_And_Trailer * header_and_trailer,
| u_long bytes_to_write,
| u_long offset,
| u_long offset_high,
| u_long bytes_per_send,
| u_long flags,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Transmit_File::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_Dgram_Impl * ACE_Proactor_Impl::create_asynch_write_dgram ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Write_Dgram. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_Dgram_Result_Impl * ACE_Proactor_Impl::create_asynch_write_dgram_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block * message_block,
| size_t bytes_to_write,
| int flags,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Dgram::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_File_Impl * ACE_Proactor_Impl::create_asynch_write_file ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Write_File. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_File_Result_Impl * ACE_Proactor_Impl::create_asynch_write_file_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| u_long offset,
| u_long offset_high,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Write_File::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_Stream_Impl * ACE_Proactor_Impl::create_asynch_write_stream ( | void )`[pure virtual]`

| Create the correct implementation class for doing Asynch_Write_Stream. Reimplemented in ACE_POSIX_AIOCB_Proactor, and ACE_WIN32_Proactor.

ACE_Asynch_Write_Stream_Result_Impl * ACE_Proactor_Impl::create_asynch_write_stream_result ( | ACE_Handler & handler,
| ACE_HANDLE handle,
| ACE_Message_Block & message_block,
| u_long bytes_to_write,
| const void * act,
| ACE_HANDLE event = ACE_INVALID_HANDLE,
| int priority = 0,
| int signal_number = ACE_SIGRTMIN )`[pure virtual]`

| Create the correct implementation class for ACE_Asynch_Write_Stream::Result. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

ACE_HANDLE ACE_Proactor_Impl::get_handle ( | void ) const`[pure virtual]`

| Get the event handle. Reimplemented from ACE_Event_Handler. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::handle_events ( | void )`[pure virtual]`

| Block indefinitely until at least one event is dispatched. Dispatch a single set of events. If <wait_time> elapses before any events occur, return 0. Return 1 on success i.e., when a completion is dispatched, non-zero (-1) on errors and errno is set accordingly. Reimplemented in ACE_POSIX_AIOCB_Proactor, ACE_POSIX_SIG_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::handle_events ( | ACE_Time_Value & wait_time )`[pure virtual]`

| Dispatch a single set of events. If <wait_time> elapses before any events occur, return 0. Return 1 on success i.e., when a completion is dispatched, non-zero (-1) on errors and errno is set accordingly. Reimplemented in ACE_POSIX_AIOCB_Proactor, ACE_POSIX_SIG_Proactor, and ACE_WIN32_Proactor.

virtual void ACE_Proactor_Impl::number_of_threads ( | size_t threads )`[pure virtual]`

| Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

size_t ACE_Proactor_Impl::number_of_threads ( | void ) const`[pure virtual]`

| Number of thread used as a parameter to CreatIoCompletionPort. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::post_wakeup_completions ( | int how_many )`[pure virtual]`

| Post <how_many> completions to the completion port so that all threads can wake up. This is used in conjunction with the <run_event_loop>. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::register_handle ( | ACE_HANDLE handle,
| const void * completion_key )`[pure virtual]`

| This method adds the <handle> to the I/O completion port. This function is a no-op function for Unix systems. Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

int ACE_Proactor_Impl::wake_up_dispatch_threads ( | void )`[pure virtual]`

| Add wakeup dispatch threads (reinit). Reimplemented in ACE_POSIX_Proactor, and ACE_WIN32_Proactor.

The documentation for this class was generated from the following file:

- Proactor_Impl.h